;; -*- Lisp -*-
;; $Id: $ 
;; dark/theme.jl

;; "Dark" Sawmill.
;;	Sat Jan  1 15:32:04 EST 2000
;;	rbowles@infonautics.com
;;
;; An attempt at a "next-step" theme with attributes
;; from absolute-e and shinymetal.
;;
;; new feature: button slideouts (ala E)
;; 
;; Originally built from 'absolute-sawmill' and 'shinyblue',
;; the code in this theme probably no longer resembles its
;; predecessors, or anything sane for that matter.
;;
;; Please feel free to offer comments/suggestions.
;;

;; TODO:
;;	- cleanup code.
;;	- cleanup inconsistent indentation.
;;	- variable scope, what's that?
;;	- hard-coded variables...
;;	- Track down the SEGV that this theme occasionally generates
;;		on alpha's (glibc-2.1.2-17, linux-2.2.14pre5+raid)



;; credits and thanks:
;; (if I've left you out, please let me know)
;; 	absolute-sawmill	(Mike Bond)
;;	shinyblue(sawmill)	<satoru@d1.dion.ne.jp>
;;	shinyblue(etheme)	<khyron@choice.net>
;;	ShinyMetal(etheme)	http://www.elightenment.com/
;; last but not least to:
;;	http://sawmill.sourceforge.net/


(defgroup dark-frame "Dark Theme")

(defcustom dark:foreground "white"
	"Title foreground color"
	:group dark-frame
	:type color)

(defcustom dark:full-title t
	"Use full width of window for title and buttons"
	:group dark-frame
	:type boolean)

(defcustom dark:shrink-shaped-title nil
	"Shrink title to width of title text when shaded"
	:group dark-frame
	:type boolean)

(defcustom dark:slideout-default nil
	"Show extra (slideout) buttons by default."
	:group dark-frame
	:type boolean)

(defcustom dark:debug-p nil
	"print debugging output"
	:group dark-frame
	:type boolean)

(defcustom dark:border-width 4
	"Width of window border"
	:group dark-frame
	:type number
	:range (1 . nil))

(defcustom dark:tab-width 24
	"Width of resizebar tabs"
	:group dark-frame
	:type number
	:range (1 . nil))

(defcustom dark:tab-height 6
	"Height of resizebar"
	:group dark-frame
	:type number
	:range (1 . nil))

(defvar dark:slideout-indent 5)

(defvar dark:dprint (lambda (p) ((if dark:debug-p print nop) p)))

;; ---- start frame class definitions ---- ;;

;; frame class: slideout-button
(def-frame-class slideout-button
	'((cursor . arrow))
	 (bind-keys slideout-button-keymap
		"Button1-Off" 'fdark:slideout-toggle
		"Button2-Off" 'fdark:slideout-inc
		"Button3-Off" 'popup-window-menu
	)
)

;; frame class: stick-button
(def-frame-class stick-button
	'((cursor . arrow))
	 (bind-keys stick-button-keymap
		"Button1-Off" 'toggle-window-sticky
	)
)

;; frame class: shade-button
(def-frame-class shade-button
	'((cursor . arrow))
	 (bind-keys shade-button-keymap
		"Button1-Off" 'toggle-window-shaded
	)
)

;; frame class: dark:maximize-button
(def-frame-class dark:maximize-button
	'((cursor . arrow))
	 (bind-keys dark:maximize-button-keymap
		"Button1-Off" 'maximize-fill-window-vertically-toggle
		"Button2-Off" 'maximize-fill-window-horizontally-toggle
		"Button3-Off" 'maximize-fill-window-toggle
	)
)

;; ---- end frame class definitions ---- ;;
(defvar fdark:slideout-c (lambda (w) (apply max 0
	(append (delete-if
		(lambda (i) (eq i 'nil))
		(mapcar
			(lambda (f) (cdr (assoc 'slideout f)))
			(window-frame w)
		)
	) '(0 0))
)))

;; (rassq 'foo-button (mapcar (lambda (f) (assoc 'class f)) (window-frame w)))
;; (apply max
;;	(delete-if (lambda (i) (eq i 'nil))
;;		(mapcar (lambda (f) (cdr (assoc 'slideout f)))
;;			(window-frame wt))))
(defvar fdark:frame (lambda (w &optional type ns-cnt)
	(let* (
		(ns-cnt (if (eq 'nil ns-cnt) 0 ns-cnt))
		(type (if (eq 'nil type) 'default type))
	)
	(dark:dprint (format nil "(%s '%s %s)\n--"
		"fdark:frame" type ns-cnt))
	(cond
		((eq type 'shaped-transient)
			transient-titlebar)
		((eq type 'transient) (append
			transient-titlebar
			dark-sides
			dark-resizebar))
		((eq type 'unframed)
			nil-frame)
		((eq type 'shaped)
			(dark-titlebar 'frame2 0 ns-cnt))
		((eq type 'default) (append
			(dark-titlebar 'frame2 dark:border-width ns-cnt)
			dark-sides dark-resizebar
		))
		(t (append
			(dark-titlebar 'frame2 dark:border-width ns-cnt)
			dark-sides dark-resizebar
		))
	))
))

(defvar fdark:slideout-inc (lambda (w)
	"hello"
	(interactive "%W")
	(set-window-frame w
	(fdark:frame w (window-type w) (% (+ (fdark:slideout-c w) 1) 6)))
))

(defvar fdark:slideout-on (lambda (w)
	"hello"
	(interactive "%W")
	(set-window-frame w
	(fdark:frame w (window-type w) 5))
))

(defvar fdark:slideout-toggle (lambda (w)
	"hello"
	(interactive "%W")
	(set-window-frame w
	(fdark:frame w (window-type w) (if (eq 0 (fdark:slideout-c w)) 5 0)))
))

(defvar dark:iconify-images
	(mapcar (lambda (i) (set-image-border (make-image i) 4 4 4 4)) '(
	"pix/iconify_normal.xpm"
	"pix/iconify_normal_active.xpm"
	"pix/iconify_hilited_active.xpm"
	"pix/iconify_clicked_active.xpm"
)))

(defvar dark:icoslide-images
	(mapcar (lambda (i) (set-image-border (make-image i) 4 4 4 4)) '(
	"pix/iconify_normal.xpm"
	"pix/iconify_normal_active.xpm"
	"pix/slideout_hilited_active.xpm"
	"pix/slideout_clicked_active.xpm"
)))

(defvar dark:bar-images
	(mapcar (lambda (i) (set-image-border (make-image i) 4 4 4 4)) '(
	"pix/bar_normal.xpm"
	"pix/bar_normal_active.xpm"
	"pix/bar_hilited_active.xpm"
	"pix/bar_clicked_active.xpm"
)))
(defvar dark:close-images
	(mapcar (lambda (i) (set-image-border (make-image i) 4 4 4 4)) '(
	"pix/close_normal.xpm"
	"pix/close_normal_active.xpm"
	"pix/close_hilited_active.xpm"
	"pix/close_clicked_active.xpm"
)))
(defvar dark:slideout-images
	(mapcar (lambda (i) (set-image-border (make-image i) 4 4 4 4)) '(
	"pix/slideout_normal.xpm"
	"pix/slideout_normal_active.xpm"
	"pix/slideout_hilited_active.xpm"
	"pix/slideout_clicked_active.xpm"
)))
(defvar dark:stick-images
	(mapcar (lambda (i) (set-image-border (make-image i) 4 4 4 4)) '(
	"pix/stick_normal.xpm"
	"pix/stick_normal_active.xpm"
	"pix/stick_hilited_active.xpm"
	"pix/stick_clicked_active.xpm"
)))
(defvar dark:shade-images
	(mapcar (lambda (i) (set-image-border (make-image i) 4 4 4 4)) '(
	"pix/shade_normal.xpm"
	"pix/shade_normal_active.xpm"
	"pix/shade_hilited_active.xpm"
	"pix/shade_clicked_active.xpm"
)))
(defvar dark:maximize-images
	(mapcar (lambda (i) (set-image-border (make-image i) 4 4 4 4)) '(
	"pix/maximize_normal.xpm"
	"pix/maximize_normal_active.xpm"
	"pix/maximize_hilited_active.xpm"
	"pix/maximize_clicked_active.xpm"
)))

(let* (
;; -- start-let-definitions -- ;;

(fdark:tab-width	(lambda () dark:tab-width))
(fdark:-tab-width	(lambda () (- dark:tab-width)))
(fdark:tab-height	(lambda () dark:tab-height))
(fdark:-tab-height	(lambda () (- dark:tab-height)))
(fdark:border-width	(lambda () dark:border-width))
(fdark:-border-width	(lambda () (- dark:border-width)))
(fdark:foreground 	(lambda () dark:foreground))
(fdark:full-title	(lambda () dark:full-title))

;; -- end-let-definitions -- ;;
) 
;; -- start-let-body -- ;;

;; Frame-Part Definitions (ouch)
;;	I'm using 'defvar' so that we can refer to them
;;	from outside the theme itself.
;;
	(defvar dark-titlebar (lambda (&optional type insets s-cnt) (let* (
		(i 0)
		(btn-width 16)
		(btn2width (* 2 btn-width))
		(btn-height 16)
		(insets2 (* 2 insets))
		(l-indent (if s-cnt (* btn-width s-cnt) 0))
		(t-top-edge (- btn-height))
		(w-width (lambda (w) (+ (car (window-dimensions w)) insets2)))
		(shade-shrink-p (lambda (w) (and
			(eq dark:shrink-shaped-title 't)
			(window-get w 'shaded)
		)))

		(slideout-left-edge (lambda () (- insets)))
		;; (slideout-width (lambda (w) (if
		;;	(eq (input-focus) w) btn-width 0)))

		(t-left-edge (lambda () (- (+ btn-width l-indent) insets)))
		(t-text-w (lambda (w) (text-width (window-name w))))
		(t-width (lambda (w) (cond
			((or (eq dark:full-title 'nil) (shade-shrink-p w))
				(max	0
					(min (- (w-width w) btn2width l-indent)
						(max 64
						(+ 10 (t-text-w w))
					))))
			(t (max 0 (- (w-width w) btn2width l-indent))))))
		;;(t-left-edge (lambda (w) (- btn-width insets
		;;	(if (eq (input-focus) w) 0 btn-width))))


		(close-left-edge (lambda (w)
			(+ (t-left-edge w) (t-width w))
		))
		(close-right-edge (lambda (w) (- (w-width w)
			(t-width w) (t-left-edge) btn-width insets2)))

		(rhs-left-edge (lambda (w) (if (shade-shrink-p w)
			(+ (t-left-edge w) (t-width w))
			(+ (t-left-edge w) (t-width w) btn-width)
		)))
		(rhs-right-edge (lambda (w) (if (shade-shrink-p w)
			(- (w-width w) (t-width w) btn-width insets)
			(- insets)
		)))
		(sb `(
			(slideout-button . ,dark:icoslide-images)
			(shade-button . ,dark:shade-images)
			(stick-button . ,dark:stick-images)
			(dark:maximize-button . ,dark:maximize-images)
			(iconify-button . ,dark:iconify-images)
			(iconify-button . ,dark:iconify-images)
		))
		(mk-slideout (lambda (i) (list
			`(class . ,(car (nth i sb )))
			`(background . ,(cdr (nth i sb)))
			`(slideout . ,i)
			`(left-edge . ,(- (* btn-width i) insets))
			`(width . ,btn-width)
			`(top-edge . ,t-top-edge)
			`(height . ,btn-height)
			`(removable . t)
		)))
	)
		(delete-if (lambda (l) (not l)) (list
			;; title bar
			`((class . title)(background . ,dark:bar-images)
				(foreground "white" "green" "white" "white")
				(text . ,window-name)
				(x-justify . center)
				(y-justify . center)
				(left-edge . ,t-left-edge)
				(width . ,t-width)
				(top-edge . ,t-top-edge)
				(height . ,btn-height))
			;; close button
			`((class . close-button)
				(background . ,dark:close-images)
				;; (left-edge . ,close-left-edge)
				(right-edge . ,close-right-edge)
				(width . ,btn-width)
				(top-edge . ,t-top-edge)
				(removable . t)
				(height . ,btn-height))
			;; rhs skinny titlebar extension
			`((class . top-border) (background . ,dark:bar-images)
				(left-edge . ,rhs-left-edge)
				(right-edge . ,rhs-right-edge)
				(top-edge . ,fdark:-tab-height)
				(height . ,fdark:tab-height))
			(if (> s-cnt -1) (mk-slideout 0))
			(if (> s-cnt 0) (mk-slideout 1))
			(if (> s-cnt 1) (mk-slideout 2))
			(if (> s-cnt 2) (mk-slideout 3))
			(if (> s-cnt 3) (mk-slideout 4))
			(if (> s-cnt 4) (mk-slideout 5))
		))

	)))

	(defvar dark-sides `(
		;; left frame
		((class . right-border)(background . ,dark:bar-images)
			(right-edge . ,fdark:-border-width)
			(width . ,fdark:border-width)
			(top-edge . 0)
			(bottom-edge . ,fdark:-tab-height))
		;; right frame
		((class . left-border)(background . ,dark:bar-images)
			(left-edge . ,fdark:-border-width)
			(width . ,fdark:border-width)
			(top-edge . 0)
			(bottom-edge . ,fdark:-tab-height))
		))

	(defvar dark-resizebar `(
		;; bottom frame
		((class . bottom-border)(background . ,dark:bar-images)
			(left-edge . ,fdark:tab-width)
			(right-edge . ,fdark:tab-width)
			(bottom-edge . ,fdark:-tab-height)
			(height . ,fdark:tab-height))
		;; bottom-left corner
		((class . bottom-left-corner)(background . ,dark:bar-images)
			(left-edge . 0)
			(width . ,fdark:tab-width)
			(bottom-edge . ,fdark:-tab-height)
			(height . ,fdark:tab-height))
		;; bottom-right corner
		((class . bottom-right-corner)(background . ,dark:bar-images)
			(right-edge . 0)
			(width . ,fdark:tab-width)
			(bottom-edge . ,fdark:-tab-height)
			(height . ,fdark:tab-height))
		))

	(defvar transient-titlebar `(
		((class . top-border) (background . ,dark:bar-images)
			(top-edge . ,fdark:-tab-height)
			(height . ,fdark:tab-height)
			(left-edge . 0)
			(right-edge . 0))
		((class . top-left-corner) (background . ,dark:bar-images)
			(top-edge . ,fdark:-tab-height)
			(height . ,fdark:tab-height)
			(left-edge . ,fdark:-border-width)
			(width . ,fdark:border-width))
		((class . top-right-corner) (background . ,dark:bar-images)
			(top-edge . ,fdark:-tab-height)
			(height . ,fdark:tab-height)
			(right-edge . ,fdark:-border-width)
			(width . ,fdark:border-width))
	))

	(add-frame-style 'dark
		(lambda (w type)
			(cond
			((eq type 'shaped)
				(dark-titlebar 'frame 0 0))
			((eq type 'shaped-transient)
				transient-titlebar)
			((eq type 'transient) (append
				transient-titlebar
				dark-sides
				dark-resizebar))
			((eq type 'unframed) nil-frame)
			(t (append
				(dark-titlebar 'frame dark:border-width 0)
				dark-sides
				dark-resizebar))
			)
		)
	)

	;; called after the WM_NAME property changes
	(call-after-property-changed 'WM_NAME (lambda (w)
		(if (eq (window-get w 'current-frame-style) 'dark)
			(rebuild-frame w))
	))
) ;; -- end-let-body -- ;;

(mapc (lambda (sym)
	(custom-set-property sym ':after-set
		(lambda() (mapc (lambda (w) (when
			(eq (window-get w 'current-frame-style) 'dark)
				(rebuild-frame w)
		)) (managed-windows)))

))
	'(dark:foreground
		dark:full-title
		dark:shrink-shaped-title
		dark:border-width))

